#!/usr/bin/env python2.2
'''Zulk-BOT

VERSION: 2.0.0

Made in sweden by TheZulk ( thezulk at yahoo.com )
'''
# This code uses the GPL license, read the GPL before using this code
# There should be a LICENSE file with this code, but if there isn't
# you can get it at: http://www.gnu.org/licenses/gpl.txt

from sys import argv,exit,exc_info
from inspect import getframeinfo
from os import environ
from socket import *
from threading import _start_new_thread
from time import sleep
from os.path import exists
import re
import pickle
try:
	import readline
except:
	print 'Warning: Readline not found\n\n\n'

global sock,curNick,iName,fString,passwd,running,server,configFile

progVer = '2.0.0'

######################## Settings ############################

orgNickList = ['zlkbot2_0','zulk_bot','mandel']
iName = 'thezulk'
fString = 'I\'m a zulk-bot'
passwd = 'linux_rulez'
version = 'Zulk-bot version ' + progVer + '. Made from scratch in python by TheZulk'
server = 'irc.webgiro.se'
onConnect = ['JOIN #ldream']
onJoin = {'#ldream':['PRIVMSG #ldream :Like a napkin in the air']}
scriptDir = 'scripts'
scriptList = ['ctcp.py','login.py','config.py']
globalScripts = ['security.py','globals.py']

##################### Leave these blank #######################

# the message stack and string used in "getString()"
strStack = []
string = ''

# dict with search patterns and replies
comList = {}

# list containing autherized users
authUsers = []

# the configuration file
configFile = ''

# compiled scripts
scripts = []

##################### Code stars here #########################
nickList = orgNickList+[] # hack to copy list instead of getting a pointer to it
curNick = nickList.pop(0) # select first nick in nickList

def readConfig():
	global comList,passwd,server,scriptDir,scriptList
	print 'Loading config from "' + configFile + '"'
	if exists(configFile):
		cfgFile=open(configFile)

		comList = pickle.load(cfgFile)
		passwd = pickle.load(cfgFile)
		server = pickle.load(cfgFile)
		scriptDir = pickle.load(cfgFile)
		scriptList = pickle.load(cfgFile)

		cfgFile.close()

def writeConfig():
	print 'Writing config to "' + configFile + '"'
	cfgFile=open(configFile,'w')

	pickle.dump(comList,cfgFile)
	pickle.dump(passwd,cfgFile)
	pickle.dump(server,cfgFile)
	pickle.dump(scriptDir,cfgFile)
	pickle.dump(scriptList,cfgFile)

	cfgFile.close()

def getString():
	'''Stripps down data from IRC server and returns the next server command'''
	global sock,strStack,string,server
#	is the message stack empty?
	if len(strStack) <= 0:
#		catch errors
		try:
#			get messages from server
			text = sock.recv(1024)
#		has an error acured?
		except:
#			reconnect to the server
			return ''
#		append the server messages to the message stack
		for a in text:
			if a == '\r':
				strStack.append(string)
				string = ''
				continue
			if a == '\n':
				continue
			string += a
#	is the stack still empty?
	if len(strStack) == 0:
#		return an empty string
		return ''
#	return the next command from the stack
	return strStack.pop()

def splitCmd(inText):
	cmdDict = {}
	cmdDict['raw'] = inText
	if inText[0] == ':':
		bigTmpList = inText.split(':',2)
		smallTmpList = bigTmpList[1].split()

		host = smallTmpList[0].split('!')
		if len(host) > 1:
			cmdDict['nick'] = host[0]
			cmdDict['host'] = host[1]
			cmdDict['ip'] = host[1].split('@')[1]
		else:
			cmdDict['nick'] = host[0]
		cmdDict['cmd'] = smallTmpList[1]
		if smallTmpList[-1][0] == '#':
			cmdDict['chan'] = smallTmpList[-1]
		else:
			cmdDict['target'] = smallTmpList[-1]
		if cmdDict.has_key('chan'):
			cmdDict['back'] = cmdDict['chan']
		else:
			cmdDict['back'] = cmdDict['nick']
		if len(bigTmpList) > 2:
			cmdDict['text'] = bigTmpList[2]
	else:
		cmdDict['cmd'] = inText.split(':')[0].strip()
		cmdDict['text'] = inText.split(':',1)[1]
	return cmdDict

def cmdHandler(cmdDict):
	global scriptList,commands
	commands = []
	if cmdDict['cmd'] == 'PING':
		commands.append('PONG :' + cmdDict['text'])
	print str(cmdDict)

	for a in scripts:
		try:
			exec(a,globals(),locals())
		except:
			print exc_info()[0]
			print exc_info()[1]
			print 'file: ' + str(getframeinfo(exc_info()[2])[0])
			print 'line: ' + str(getframeinfo(exc_info()[2])[1])
			for i in  getframeinfo(exc_info()[2])[3]: print i
		
	return commands


def read_sock():
	global sock,running,server
	print 'Thread started'

	while running:
		text = getString()
		if text == '':
			if running:
				sock.close()
				connect(server,6667)
				continue
#		print '<server> ' + text

#		try:
		outText = cmdHandler(splitCmd(text))
#		except:
#			print "Error"
#			outText = ['PRIVMSG '+ text.split(':')[1].split('!')[0] + ' :Unhandled error handled! Please send bug report to TheZulk!']
		if outText != []:
			for text in outText:
				if text != '':
					sock.send(text + '\r\n')
					print '<me> ' + text
	print 'Thread exiting... the program shouldn\'t be running now'
	exit(0)

def connect(server,port):
	'''Connects to the specified server and will try untill connected'''
	global sock,iName,fString,curNick
	again = 1
	while again:
		try:
			sock=socket(AF_INET,SOCK_STREAM)
			sock.connect((server,port))

			sock.send('NICK '+curNick+'\r\n')
			print '<me> NICK '+curNick

			sock.send('USER '+iName+' p2.zlk '+server+' :'+fString+'\r\n')
			print '<me> USER '+iName+' p2.zlk '+server+' :'+fString
			again = 0
		except:
			print 'Error connecting... waiting for 5 seconds'
			sleep(5)
			print 'reconnecting\n'


def loadScripts():
	global security, scripts, scriptList
	scriptBackup = scripts + []
	scripts = []
	try:
		for i in scriptList:
			print 'Loading "' + i + '"'
			scripts.append(compile(open(scriptDir+'/'+i).read().replace('\r\n','\n')+'\n',i,'exec'))
		print 'Running "security.py"'
		exec(compile(open(scriptDir+'/'+'security.py').read().replace('\r\n','\n')+'\n','security.py','exec'))
		print 'Running "globals.py"'
		exec(compile(open(scriptDir+'/'+'globals.py').read().replace('\r\n','\n')+'\n','globals.py','exec'))
	except:
		scripts = scriptBackup + []
		print exc_info()[0]
		print exc_info()[1]
		print 'line: ' + str(getframeinfo(exc_info()[2])[1])
		for i in getframeinfo(exc_info()[2])[3]: print i
		return 1
	return 0

if __name__ == '__main__':
	if len(argv) > 1:
		server = argv[1]
		print server

	configFile = './.zulkbot2-' + server
	readConfig()

	if loadScripts():
		print "Error loading scripts"
		exit(1)

	connect(server,6667)
	running = 1
	thread = _start_new_thread(read_sock, tuple())

	while running:
		cmdHandler({'nick':'local nick',
				'ip':'local',
				'cmd':'PRIVMSG',
				'host':'me@not possible',
				'target':'local nick',
				'back':'local nick',
				'text':raw_input()})
		for i in commands: sock.send(i+'\r\n')
		#sock.send(raw_input()+'\r\n')
